﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Runtime.Serialization;

namespace ScriptifyLibrary20
{
    [Serializable]
    public class MyMessageException : System.Exception
    {
        protected MyMessageException(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }

        public MyMessageException(string message, Exception innerException) 
            : base(message, innerException)
        {
        }
    }


    [Serializable]
    public class MyApplicationException : System.Exception
    {
        protected MyApplicationException(SerializationInfo info, StreamingContext context)
            : base(info, context)
        {
        }

        public MyApplicationException(string message, Exception innerException)
            : base(message, innerException)
        {
        }
    }
}
